VERSION 5.00
Begin VB.UserControl ListViewCtl 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   1320
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4860
   ClipBehavior    =   0  'None
   ClipControls    =   0   'False
   ControlContainer=   -1  'True
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9
      Charset         =   186
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   HasDC           =   0   'False
   HitBehavior     =   0  'None
   ScaleHeight     =   1320
   ScaleWidth      =   4860
End
Attribute VB_Name = "ListViewCtl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event KeyDown(ByVal VirtualKey_ As Integer)
Public Event ActivateItem(ByVal Index_ As Long)
Attribute ActivateItem.VB_Description = "Font properties must be stored under FontKey/UniListViewFont !!!String!!! type registry values"
Public Event MouseRightClick()
Public Event SelectionChanged(ByVal Index_ As Long)
Public Event ColumnClick(ByVal ColIndex_ As Long)
Public Event OnItemCheck(ByVal Index As Long)
Public Event ResizeEnd()

Public Enum SortOrder
    None = 0
    Ascending = LVS_SORTASCENDING
    Descending = LVS_SORTDESCENDING
End Enum

Public Enum ViewStyle
    Icon = LVS_ICON
    Report = LVS_REPORT
    SmallIcons = LVS_SMALLICON
    List = LVS_LIST
End Enum

Public Enum ActivateStyle
    Normal = 0
    OneClick = LVS_EX_ONECLICKACTIVATE
    DblClick = LVS_EX_TWOCLICKACTIVATE
End Enum

Public Enum winBorderStyle
    Flat = 0
    Sunken = WS_EX_STATICEDGE
End Enum

Private myPropFullRowSel As Boolean
Private myPropGrid As Boolean
Private myPropCheck As Boolean
Private myPropFlatSbar As Boolean
Private myPropUnderline As Boolean
Private myPropHeadDragDrop As Boolean
Private myPropMultiSel As Boolean
Private myPropSort As SortOrder
Private myPropWrap As Boolean
Private myPropEdit As Boolean
Private myPropNoScroll As Boolean
Private myPropHideHead As Boolean
Private myPropStyle As ViewStyle
Private myPorpBorder As Boolean
Private myPropShowSel As Boolean
Private myPropActivate As ActivateStyle
Private myPropFColor As OLE_COLOR
Private myPropBColor As OLE_COLOR
'Private myPropAlignLeft As Boolean
'Private myPropAutoArrange As Boolean
'Private myPropUnderlineCold As Boolean

Private myHead As String
Private myColArr As Variant 'split header
Private myReadPropFlag As Boolean
Private myhWnd As Long
Private myOrigWndProc As Long
Private myPropNoHeadClck As Boolean
Private myProp3D As Boolean
Private myPropWinBorder As winBorderStyle
Private myTextBuf As String
Private myUTF8 As Boolean
Private myFontKey As String 'registry key for global font settings
Private MyOrderBy As Integer


Public Property Get hwnd() As Long
71 Let hwnd = myhWnd
End Property

Public Property Get UTF8() As Boolean
76 Let UTF8 = myUTF8
End Property

Public Property Let UTF8(newval_ As Boolean)
80 Let myUTF8 = newval_
End Property

Public Property Get FontKey() As String
84 Let FontKey = myFontKey
End Property

Public Property Let FontKey(newval_ As String)
On Error GoTo TrapSub '+++
89 On Error Resume Next
90 Let myFontKey = newval_
91 If myFontKey <> "" Then  'use global font if key is specified
92    UserControl.Font.Bold = GetSetting(myFontKey, "UniListViewFont", "Bold", UserControl.Font.Bold)
93    UserControl.Font.Charset = GetSetting(myFontKey, "UniListViewFont", "Charset", UserControl.Font.Charset)
94    UserControl.Font.Italic = GetSetting(myFontKey, "UniListViewFont", "Italic", UserControl.Font.Italic)
95    UserControl.Font.Name = GetSetting(myFontKey, "UniListViewFont", "Name", UserControl.Font.Name)
96    UserControl.Font.Size = GetSetting(myFontKey, "UniListViewFont", "Size", UserControl.Font.Size)
97 End If
98 On Error GoTo 0
99 Set Font = UserControl.Font
Err.Clear '+++
TrapSub: If Err <> 0 Then  '+++
Err.Raise vbObjectError, , "ListViewCtl.Let FontKey, line " & Erl & vbCrLf & Err.Description  '+++
End If '+++
End Property

Public Property Get Appearance() As winBorderStyle
107 Let Appearance = myPropWinBorder
End Property

Public Property Let Appearance(newval_ As winBorderStyle)
111 Let myPropWinBorder = newval_
End Property


Public Property Get NoColumnClick() As Boolean
115 Let NoColumnClick = myPropNoHeadClck
End Property

Public Property Let NoColumnClick(newval_ As Boolean)
120 Let myPropNoHeadClck = newval_
End Property

'--------------------------------- Public methods --------------------------------
Public Sub SetFocus()
124 Dim oldwnd_ As Long
125 If ListIndex > -1 Then oldwnd_ = SetFocusAPI(myhWnd)
End Sub

Public Function DeleteAllItems() As Boolean
130 DeleteAllItems = SendMessage(myhWnd, LVM_DELETEALLITEMS, 0, ByVal 0&)
End Function

Public Function GetCountPerPage() As Long
134 GetCountPerPage = SendMessage(myhWnd, LVM_GETCOUNTPERPAGE, 0, ByVal 0&)
End Function
 
Public Function GetTopIndex() As Long
138 GetTopIndex = SendMessage(myhWnd, LVM_GETTOPINDEX, 0, ByVal 0&)
End Function

Public Function GetItemCount() As Long
142 GetItemCount = SendMessage(myhWnd, LVM_GETITEMCOUNT, 0, ByVal 0&)
End Function


'-------------------------------- Poperties ---------------------------------------
Public Property Get ListIndex() As Long
146 Let ListIndex = GetNextItem(-1, LVNI_SELECTED)    'FIRST SELECTED DITEM
End Property

Public Property Let ListIndex(newval_ As Long)
152 SetItemState newval_, &HFF, LVISEnum.LVIS_SELECTED Or LVISEnum.LVIS_FOCUSED
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
156 Let ForeColor = myPropFColor
End Property

Public Property Let ForeColor(newval_ As OLE_COLOR)
160 myPropFColor = newval_
161 SetTextColor GetSysColor(&HFF And myPropFColor)
End Property

Public Property Get BackColor() As OLE_COLOR 'VBRUN.SystemColorConstants
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
165 Let BackColor = myPropBColor 'GetBkColor()
End Property

Public Property Let BackColor(newval_ As OLE_COLOR) 'VBRUN.SystemColorConstants)
169 myPropBColor = newval_
170 SetBkColor GetSysColor(&HFF And myPropBColor)
171 SetTextBkColor GetSysColor(&HFF And myPropBColor)
172 UserControl.Refresh
End Property

Public Property Get Font() As StdFont
176 Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal vNewValue As StdFont)
180 Set UserControl.Font = vNewValue
181 Dim hFont_ As Long
182 If myhWnd <> 0 Then
183    hFont_ = SendMessage(UserControl.hwnd, WM_GETFONT, 0, 0)
184    If hFont_ <> 0 Then SendMessage myhWnd, WM_SETFONT, hFont_, 0
185 End If
End Property

Public Function Selection() As String
189 Dim sel_ As Long
190 sel_ = GetNextItem(-1, LVNI_SELECTED)
191 If sel_ > -1 Then
192    Selection = GetItemText(sel_, 0)
193 End If
End Function

Public Function SelectionRow() As Variant
197 Dim sel_ As Long, n0_ As Long, n1_ As Long, n_ As Long, arr_ As Variant
198 sel_ = GetNextItem(-1, LVNI_SELECTED)
199 If sel_ > -1 Then
200    arr_ = myColArr
201    n0_ = LBound(arr_)
202    n1_ = UBound(arr_)
203    For n_ = n0_ To n1_
204       arr_(n_) = GetItemText(sel_, n_ - n0_)
205    Next n_
206    SelectionRow = arr_
207 End If
End Function

Public Property Get ActivationStyle() As ActivateStyle
211 Let ActivationStyle = myPropActivate
End Property

Public Property Let ActivationStyle(newval_ As ActivateStyle)
215 Let myPropActivate = newval_
End Property

Public Property Get HideSelection() As Boolean
219 Let HideSelection = myPropShowSel
End Property

Public Property Let HideSelection(newval_ As Boolean)
223 Let myPropShowSel = newval_
End Property

Public Property Get Border() As Boolean
227 Let Border = myPorpBorder
End Property

Public Property Let Border(newval_ As Boolean)
231 Let myPorpBorder = newval_
End Property

Public Property Get ViewStyle() As ViewStyle
235 Let ViewStyle = myPropStyle
End Property

Public Property Let ViewStyle(newval_ As ViewStyle)
239 Let myPropStyle = newval_
End Property

Public Property Get HideColumnHeaders() As Boolean
243 Let HideColumnHeaders = myPropHideHead
End Property

Public Property Let HideColumnHeaders(newval_ As Boolean)
247 Let myPropHideHead = newval_
End Property

Public Property Get NoScroll() As Boolean
251 Let NoScroll = myPropNoScroll
End Property

Public Property Let NoScroll(newval_ As Boolean)
255 Let myPropNoScroll = newval_
End Property

Public Property Get LabelEdit() As Boolean
259 Let LabelEdit = myPropEdit
End Property

Public Property Let LabelEdit(newval_ As Boolean)
263 Let myPropEdit = newval_
End Property

Public Property Get LabelWrap() As Boolean
267 Let LabelWrap = myPropWrap
End Property

Public Property Let LabelWrap(newval_ As Boolean)
271 Let myPropWrap = newval_
End Property

Public Property Get Sort() As SortOrder
275 Let Sort = myPropSort
End Property

Public Property Let Sort(newval_ As SortOrder)
279 Let myPropSort = newval_
End Property

Public Property Get MultiSelect() As Boolean
283 Let MultiSelect = myPropMultiSel
End Property

Public Property Let MultiSelect(newval_ As Boolean)
287 Let myPropMultiSel = newval_
End Property

Public Property Get HeaderDragDrop() As Boolean
291 Let HeaderDragDrop = myPropHeadDragDrop
End Property

Public Property Let HeaderDragDrop(newval_ As Boolean)
295 Let myPropHeadDragDrop = newval_
296 SetExtendedStyle
End Property

Public Property Get HotTracking() As Boolean
300 Let HotTracking = myPropUnderline
End Property

Public Property Let HotTracking(newval_ As Boolean)
304 Let myPropUnderline = newval_
305 SetExtendedStyle
End Property

Public Property Get FlatScrollbar() As Boolean
309 Let FlatScrollbar = myPropFlatSbar
End Property

Public Property Let FlatScrollbar(newval_ As Boolean)
313 Let myPropFlatSbar = newval_
314 SetExtendedStyle
End Property

Public Property Get CheckBoxes() As Boolean
318 Let CheckBoxes = myPropCheck
End Property

Public Property Let CheckBoxes(newval_ As Boolean)
322 Let myPropCheck = newval_
323 SetExtendedStyle
End Property

Public Property Get GridLines() As Boolean
327 Let GridLines = myPropGrid
End Property

Public Property Let GridLines(newval_ As Boolean)
331 Let myPropGrid = newval_
332 SetExtendedStyle
End Property

Public Property Get FullRowSelect() As Boolean
336 Let FullRowSelect = myPropFullRowSel
End Property

Public Property Let FullRowSelect(newval_ As Boolean)
340 Let myPropFullRowSel = newval_
341 SetExtendedStyle
End Property

Public Property Get Header() As String
345 Let Header = myHead
End Property

Public Property Let Header(newval_ As String)
349 Dim n_ As Long, n0_ As Long, n1_ As Long, cl_ As LVCOLUMN, ss_ As Long, wpx_ As Long
350 Let myHead = newval_
351 DeleteAllItems


354 myColArr = Split(myHead, "|")
355 n0_ = LBound(myColArr)
356 n1_ = UBound(myColArr)
357 wpx_ = ScaleX(ScaleWidth, ScaleMode, vbPixels)
358 ss_ = Len(myHead) - (n1_ - n0_)

360 cl_.mask = LVCF_SUBITEM
361 Do While GetColumn(0, cl_)    'clear remaining columns
362    DeleteColumn 0
363 Loop
364 With cl_
365    .mask = LVCF_TEXT Or LVCF_WIDTH Or LVCF_FMT Or LVCF_SUBITEM
366    .fmt = LVCFMT_LEFT
367 End With

369 For n_ = n0_ To n1_
370    With cl_
371       .lpszText = strPtr(myColArr(n_))
372       .cx = Int(wpx_ * Len(myColArr(n_)) / ss_)       'scale relative column widths
373       .subitem = n_
374    End With
375    InsertColumn n_, cl_
376 Next n_

End Property


Public Sub Clear()
381 DeleteAllItems 'clear list
End Sub

'Fill list from matrix
Public Function SetColumns(matrix_ As Variant) As Boolean
386 Dim n_ As Long, n0_ As Long, n1_ As Long
387 Dim r_ As Long, r0_ As Long, r1_ As Long
388 Dim v_ As Variant
389 Dim lvi_ As LVITEM

391 Clear 'clear list and end notifications

393 If Not IsArray(matrix_) Then Exit Function

395 n0_ = LBound(matrix_, 1)
396 n1_ = UBound(matrix_, 1)
397 r0_ = LBound(matrix_, 2)
398 r1_ = UBound(matrix_, 2)
399 lvi_.mask = LVIF_TEXT
400 For r_ = r0_ To r1_
401    For n_ = n0_ To n1_
402       v_ = matrix_(n_, r_)
403       If IsNull(v_) Or IsEmpty(v_) Then v_ = ""
404       lvi_.cchTextMax = &H8000
405       If UTF8 Then
406          If Len(v_) = 0 Then
407             lvi_.pszText = strPtr(v_)
408          Else
409             lvi_.pszText = UTF8ToUni(v_)
410          End If
411       Else
412          lvi_.pszText = strPtr(v_)
413       End If
414       If n_ = n0_ Then 'item
415          lvi_.iSubItem = 0
416          lvi_.iItem = r_ 'inital row index for item
417          lvi_.iItem = InsertItem(lvi_)   'sorted row index for subitems
418       Else 'subitem
419          lvi_.iSubItem = n_ - n0_
420          SetItem lvi_
421       End If
422    Next n_
423 Next r_
424 SetColWidths
425 SetColumns = True
End Function

Public Function GetColumns() As Variant
430 Dim matrix_ As Variant
431 Dim n_ As Long, n0_ As Long, n1_ As Long
432 Dim r_ As Long, r0_ As Long, r1_ As Long
433 Dim Len_ As Long
434 Dim lvi_ As LVITEM

436 r1_ = GetItemCount()
437 If r1_ = 0 Then Exit Function 'return empty
'
439 lvi_.mask = LVIF_TEXT
440 lvi_.cchTextMax = Len(myTextBuf)
441 lvi_.pszText = strPtr(myTextBuf)
'number of retrievable cols from header array
443 n1_ = UBound(myColArr)
444 r1_ = r1_ - 1
445 ReDim matrix_(0 To n1_, 0 To r1_)
446 For r_ = 0 To r1_
447    For n_ = 0 To n1_
448       lvi_.iItem = r_
449       lvi_.iSubItem = n_
450       Len_ = SendMessage(myhWnd, LVM_GETITEMTEXTW, r_, lvi_)
451       matrix_(n_, r_) = Left$(myTextBuf, Len_)
452    Next n_
453 Next r_
454 GetColumns = matrix_
End Function

Public Function AddRow(ByVal Index As Long, Items_ As Variant) As Long
458 Dim n_ As Long, v_ As Variant
459 Dim lvi_ As LVITEM

461 For n_ = 0 To UBound(Items_)
462    With lvi_
463       .mask = LVIF_TEXT
464       .iSubItem = n_
465       v_ = Items_(n_)
466       If IsNull(v_) Or IsEmpty(v_) Then v_ = ""
467       If UTF8 Then
468          .pszText = IIf(v_ = "", strPtr(v_), UTF8ToUni(v_))
469       Else
'504          .pszText = strPtr(Items_(n_))
471          .pszText = strPtr(v_)
472       End If
473    End With
474    If n_ = 0 Then
475       lvi_.iItem = Index 'inital index for item
476       lvi_.iItem = InsertItem(lvi_)   'sorted index for subitems
477       AddRow = lvi_.iItem
478    Else 'subitems
479       SetItem lvi_
480    End If
481 Next n_
End Function

Public Property Get ItemChecked(ByVal Index As Long) As Boolean
485 Dim stimg_ As Long
486 stimg_ = SendMessage(myhWnd, LVM_GETITEMSTATE, Index, ByVal LVIS_STATEIMAGEMASK)
487 ItemChecked = ((stimg_ And &H2000) = &H2000)
End Property

Public Property Let ItemChecked(ByVal Index As Long, ByVal State As Boolean)
491 If State = True Then
492    SetItemState Index, &H2000, LVIS_STATEIMAGEMASK   'check state in bit 13
493 Else
494    SetItemState Index, &H1000, LVIS_STATEIMAGEMASK   'check state in bit 13
495 End If
End Property


Public Property Get ModalItemChecked(ByVal Index As Long) As Boolean
499 Dim stimg_ As Long
500 stimg_ = SendMessage(myhWnd, LVM_GETITEMSTATE, Index, LVIS_STATEIMAGEMASK)
501 ModalItemChecked = ((stimg_ Or &H2000) = &H2000)
End Property

Public Property Let ModalItemChecked(ByVal Index As Long, ByVal State As Boolean)
506 If State = True Then
507    SetItemState Index, &H2000, LVIS_STATEIMAGEMASK   'check state in bit 13
508 Else
509    SetItemState Index, &H1000, LVIS_STATEIMAGEMASK   'check state in bit 13
510 End If
End Property


'LV extended ViewStyle
Private Sub SetExtendedStyle()
514 Dim exs_ As Long
515 If Not myReadPropFlag Then
516    exs_ = IIf(GridLines, LVS_EX_GRIDLINES, 0) Or IIf(FullRowSelect, LVS_EX_FULLROWSELECT, 0) Or _
       IIf(CheckBoxes, LVS_EX_CHECKBOXES, 0) Or ActivationStyle Or _
       IIf(FlatScrollbar, LVS_EX_FLATSB, 0) Or IIf(HotTracking, LVS_EX_UNDERLINEHOT, 0)

518    SetExtendedListViewStyle exs_, &HFFFFFFFF
519 End If
End Sub


Private Function SetUnicodeFormat(ByVal fUnicode As Long)
527 Call SendMessage(myhWnd, CCM_SETUNICODEFORMAT, (fUnicode), ByVal 0&)
End Function

Private Function GetUnicodeFormat() As Long
532 GetUnicodeFormat = SendMessage(myhWnd, CCM_GETUNICODEFORMAT, 0, ByVal 0&)
End Function

Private Function GetBkColor() As Long
536 GetBkColor = SendMessage(myhWnd, LVM_GETBKCOLOR, 0, ByVal 0&)
End Function

Private Function SetBkColor(ByVal clrBk As Long) As Boolean
540 SetBkColor = SendMessage(myhWnd, LVM_SETBKCOLOR, 0, ByVal clrBk)
End Function

Private Function GetImageList(ByVal iImageList As Long) As Long
544 GetImageList = SendMessage(myhWnd, LVM_GETIMAGELIST, (iImageList), ByVal 0&)
End Function

Private Function SetImageList(ByVal himl As Long, ByVal iImageList As Long) As Long
548 SetImageList = SendMessage(myhWnd, LVM_SETIMAGELIST, iImageList, ByVal himl)
End Function

Private Function GetItem(pitem As LVITEM) As Boolean
552 GetItem = SendMessage(myhWnd, LVM_GETITEM, 0, pitem)
End Function

Private Function SetItem(pitem As LVITEM) As Long
556 SetItem = SendMessage(myhWnd, LVM_SETITEM, 0, pitem)
End Function

Private Function InsertItem(pitem As LVITEM) As Long
560 InsertItem = SendMessage(myhWnd, LVM_INSERTITEM, 0, pitem)
End Function

Public Function DeleteItem(ByVal Index As Long)
564 DeleteItem = SendMessage(myhWnd, LVM_DELETEITEM, Index, ByVal 0&)
End Function

Private Function GetCallbackMask() As Long
568 GetCallbackMask = SendMessage(myhWnd, LVM_GETCALLBACKMASK, 0, ByVal 0&)
End Function

Private Function SetCallbackMask(ByVal mask As Long) As Long
572 SetCallbackMask = SendMessage(myhWnd, LVM_SETCALLBACKMASK, (mask), ByVal 0&)
End Function

Private Function GetNextItem(ByVal i As Long, ByVal flags As Long) As Long
576 GetNextItem = SendMessage(myhWnd, LVM_GETNEXTITEM, i, ByVal flags)
End Function

Private Function FindItem(ByVal iStart As Long, plvfi As LVFINDINFO) As Long
580 FindItem = SendMessage(myhWnd, LVM_FINDITEMW, iStart, plvfi)
End Function

Private Function GetItemRect(ByVal i As Long, prc As RECT, code) As Boolean
584 GetItemRect = SendMessage(myhWnd, LVM_GETITEMRECT, i, prc)
End Function

Private Function SetItemPosition(ByVal i As Long, ByVal x As Integer, ByVal y As Integer) As Boolean
588 Dim l_ As Long
589 l_ = MAKELPARAM((x), (y))
590 SetItemPosition = SendMessage(myhWnd, LVM_SETITEMPOSITION, i, ByVal l_)
End Function

Private Function GetItemPosition(ByVal i As Long, ppt As POINT) As Boolean
594 GetItemPosition = SendMessage(myhWnd, LVM_GETITEMPOSITION, i, ppt)
End Function

Private Function GetStringWidth(ByVal psz As String) As Long
598 GetStringWidth = SendMessage(myhWnd, LVM_GETSTRINGWIDTHW, 0, ByVal strPtr(psz))
End Function

Private Function HitTest(pinfo As LVHITTESTINFO) As Long
602 HitTest = SendMessage(myhWnd, LVM_HITTEST, 0, pinfo)
End Function

Public Function EnsureVisible(ByVal i As Long, ByVal fPartialOK As Boolean) As Boolean
606 EnsureVisible = SendMessage(myhWnd, LVM_ENSUREVISIBLE, i, ByVal fPartialOK)
End Function

Private Function Scroll(ByVal dx As Long, ByVal dy As Long) As Boolean
610 Scroll = SendMessage(myhWnd, LVM_SCROLL, ByVal dx, ByVal dy)
End Function

Public Function RedrawItems(ByVal iFirst As Long, ByVal iLast As Long) As Boolean
614 RedrawItems = SendMessage(myhWnd, LVM_FIRST + 21, ByVal iFirst, ByVal iLast)
End Function

Private Function Arrange(ByVal code As Long) As Boolean
618 Arrange = SendMessage(myhWnd, LVM_ARRANGE, ByVal code, ByVal 0&)
End Function

Private Function SetLabelEdit(ByVal i As Long) As Long
622 SetLabelEdit = SendMessage(myhWnd, LVM_EDITLABELW, ByVal i, ByVal 0&)
End Function

Private Function GetEditControlHWnd() As Long
626 GetEditControlHWnd = SendMessage(myhWnd, LVM_GETEDITCONTROL, 0, ByVal 0&)
End Function

Private Function GetColumn(ByVal iCol As Long, pcol As LVCOLUMN) As Boolean
630 GetColumn = SendMessage(myhWnd, LVM_GETCOLUMNW, ByVal iCol, pcol)
End Function

Private Function SetColumn(ByVal iCol As Long, pcol As LVCOLUMN) As Boolean
634 SetColumn = SendMessage(myhWnd, LVM_SETCOLUMNW, ByVal iCol, pcol)
End Function

Private Function InsertColumn(ByVal iCol As Long, pcol As LVCOLUMN) As Long
638 InsertColumn = SendMessage(myhWnd, LVM_INSERTCOLUMNW, ByVal iCol, pcol)
End Function

Private Function DeleteColumn(ByVal iCol As Long) As Boolean
642 DeleteColumn = SendMessage(myhWnd, LVM_DELETECOLUMN, ByVal iCol, ByVal 0&)
End Function

Private Function GetColumnWidth(ByVal iCol As Long) As Long
646 GetColumnWidth = SendMessage(myhWnd, LVM_GETCOLUMNWIDTH, ByVal iCol, ByVal 0&)
End Function

Public Function SetColumnWidth(ByVal iCol As Long, ByVal cx As Long) As Boolean
650 SetColumnWidth = SendMessage(myhWnd, LVM_SETCOLUMNWIDTH, ByVal iCol, ByVal cx)
End Function

Private Function GetHeaderHWnd() As Long
654 GetHeaderHWnd = SendMessage(myhWnd, LVM_GETHEADER, 0, ByVal 0&)
End Function

Private Function CreateDragImage(ByVal i As Long, lpptUpLeft As POINT) As Boolean
658 CreateDragImage = SendMessage(myhWnd, LVM_CREATEDRAGIMAGE, ByVal i, lpptUpLeft)
End Function

Private Function ViewRect(prc As RECT) As Boolean
662 ViewRect = SendMessage(myhWnd, LVM_GETVIEWRECT, 0, prc)
End Function

Private Function GetTextColor() As Long
666 GetTextColor = SendMessage(myhWnd, LVM_GETTEXTCOLOR, 0, ByVal 0&)
End Function

Public Function SetTextColor(ByVal clrText As Long, Optional item As Long) As Boolean
670 SetTextColor = SendMessage(myhWnd, LVM_SETTEXTCOLOR, item, ByVal clrText)
End Function

Private Function GetTextBkColor() As Long
674 GetTextBkColor = SendMessage(myhWnd, LVM_GETTEXTBKCOLOR, 0, ByVal 0&)
End Function

Private Function SetTextBkColor(ByVal clrTextBk As Long) As Boolean
678 SetTextBkColor = SendMessage(myhWnd, LVM_SETTEXTBKCOLOR, 0, ByVal clrTextBk)

End Function

Private Function GetOrigin(ppt As POINT) As Boolean
683 GetOrigin = SendMessage(myhWnd, LVM_GETORIGIN, 0, ppt)
End Function

Private Function UpdateItem(ByVal i As Long) As Boolean
687 UpdateItem = SendMessage(myhWnd, LVM_UPDATE, i, ByVal 0&)
End Function

Public Function SetItemBackColor(ByVal color As OLE_COLOR, item As Long) As Boolean
691 SendMessage myhWnd, LVM_SETTEXTBKCOLOR, item, ByVal color
692 Dim lvi As LVITEM
693 lvi.iItem = item
694 SetItem lvi
End Function

Private Function SetItemState(ByVal i As Long, ByVal flags_ As Long, ByVal mask_ As Long) As Boolean
698 Dim lvi_ As LVITEM
699 lvi_.iItem = i
700 lvi_.mask = LVIF_STATE
701 lvi_.stateMask = mask_
702 lvi_.State = flags_
703 SetItemState = SendMessage(myhWnd, LVM_SETITEMSTATE, i, lvi_)
End Function

Private Function GetItemState(ByVal i As Long, mask As Long) As Long
707 GetItemState = SendMessage(myhWnd, LVM_GETITEMSTATE, i, mask)
End Function


Public Function GetItemText(ByVal i As Long, Optional ByVal iSubItem_ As Long = 0) As String
711 Dim lvi_ As LVITEM, Len_ As Long
712 lvi_.iSubItem = iSubItem_
713 lvi_.cchTextMax = Len(myTextBuf)
714 lvi_.pszText = strPtr(myTextBuf)
715 Len_ = SendMessage(myhWnd, LVM_GETITEMTEXTW, i, lvi_)
716 GetItemText = Left$(myTextBuf, Len_)
End Function

Public Function SetItemText(ByVal i As Long, ByVal iSubItem_ As Long, pszText_ As String) As Boolean
721 Dim lvi_ As LVITEM
722 lvi_.mask = LVIF_TEXT
723 lvi_.iSubItem = iSubItem_
724 lvi_.pszText = strPtr(pszText_)
725 lvi_.cchTextMax = Len(pszText_)
726 SetItemText = SendMessage(myhWnd, LVM_SETITEMTEXTW, i, lvi_)
End Function

Private Sub SetItemCount(ByVal cItems As Long)
730 Call SendMessage(myhWnd, LVM_SETITEMCOUNT, ByVal cItems, ByVal 0&)
End Sub

Private Function SetItemCountEx(ByVal cItems As Long, ByVal dwFlags As Long)
734 Call SendMessage(myhWnd, LVM_FIRST + 47, ByVal cItems, ByVal dwFlags)
End Function

'typedef int (CALLBACK *PFNLVCOMPARE)(LPARAM, LPARAM, LPARAM);
'private Function SortItems(pfnCompare, lPrm) As Boolean
'  SortItems = SendMessage(myhWnd, LVM_SORTITEMS, lPrm, pfnCompare)
'End Function

Private Sub SetItemPosition32(ByVal i As Long, pp As POINT)
738 Call SendMessage(myhWnd, LVM_FIRST + 49, ByVal i, pp)
End Sub

Private Function SelectedCount() As Long
747 SelectedCount = SendMessage(myhWnd, LVM_GETSELECTEDCOUNT, 0, ByVal 0&)
End Function

Private Function ItemSpacing(ByVal fSmall As Long) As Long
751 ItemSpacing = SendMessage(myhWnd, LVM_GETITEMSPACING, ByVal fSmall, ByVal 0&)
End Function

Private Function ISearchString() As String
755 Dim buf As String
756 buf = String(256, 0)
757 If SendMessage(myhWnd, LVM_GETISEARCHSTRING, 0, strPtr(buf)) Then ISearchString = buf
End Function

' -1 for cx and cy means we'll use the default (system settings)
' 0 for cx or cy means use the current setting (allows you to change just one param)
Private Function SetIconSpacing(ByVal cx As Integer, ByVal cy As Integer) As Long
761 Dim l_ As Long
762 l_ = MAKELPARAM(cx, cy)
763 SetIconSpacing = SendMessage(myhWnd, LVM_SETICONSPACING, 0, ByVal l_)
End Function

Private Function SetExtendedListViewStyle(ByVal dw As Long, Optional ByVal dwMask As Long = 0) As Long
769 SetExtendedListViewStyle = SendMessage(myhWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, ByVal dwMask, ByVal dw)
End Function

Private Function GetExtendedListViewStyle() As Long
773 GetExtendedListViewStyle = SendMessage(myhWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, ByVal 0&)
End Function

Private Function SubItemRect(ByVal iItem As Long, ByVal iSubItem As Long, ByVal lvir_code As Long, prc As RECT) As Boolean
777 prc.Top = iSubItem
778 prc.Left = lvir_code
779 SubItemRect = SendMessage(myhWnd, LVM_GETSUBITEMRECT, ByVal (iItem), prc)
End Function

Private Function SubItemHitTest(plvhti As LVHITTESTINFO) As Long
783 SubItemHitTest = SendMessage(myhWnd, LVM_SUBITEMHITTEST, 0, plvhti)
End Function

Private Function SetColumnOrderArray(ByVal iCount As Long, pi() As Long) As Boolean
787 SetColumnOrderArray = SendMessage(myhWnd, LVM_SETCOLUMNORDERARRAY, ByVal iCount, pi(0))
End Function

Private Function GetColumnOrderArray(ByVal iCount As Long, pi() As Long) As Boolean
791 GetColumnOrderArray = SendMessage(myhWnd, LVM_GETCOLUMNORDERARRAY, ByVal iCount, pi(0))
End Function

Private Function SetHotItem(ByVal i As Long) As Long
795 SetHotItem = SendMessage(myhWnd, LVM_SETHOTITEM, ByVal i, ByVal 0&)
End Function

Private Function GetHotItem() As Long
799 GetHotItem = SendMessage(myhWnd, LVM_GETHOTITEM, 0, ByVal 0&)
End Function

Private Function SetHotCursor(ByVal hcur As Long) As Long
803 SetHotCursor = SendMessage(myhWnd, LVM_FIRST + 62, 0, ByVal hcur)
End Function

Private Function GetHotCursor() As Long
807 GetHotCursor = SendMessage(myhWnd, LVM_GETHOTCURSOR, 0, ByVal 0&)
End Function

Private Function ApproximateViewRect(ByVal iWidth As Integer, ByVal iHeight As Integer, ByVal iCount As Integer) As Long
811 Dim l_ As Long
812 l_ = MAKELPARAM(iWidth, iHeight)
813 ApproximateViewRect = SendMessage(myhWnd, LVM_APPROXIMATEVIEWRECT, ByVal iCount, ByVal l_)
End Function

Private Function SetWorkAreas(ByVal nWorkAreas As Long, prc As RECT) As Boolean
817 SetWorkAreas = SendMessage(myhWnd, LVM_SETWORKAREAS, nWorkAreas, prc)
End Function

Private Function GetWorkAreas(ByVal nWorkAreas As Long, prc As RECT) As Boolean
821 GetWorkAreas = SendMessage(myhWnd, LVM_GETWORKAREAS, nWorkAreas, prc)
End Function

Private Function NumberOfWorkAreas() As Long
825 Dim n_ As Long
826 If SendMessage(myhWnd, LVM_GETNUMBEROFWORKAREAS, 0, n_) Then NumberOfWorkAreas = n_
End Function

Private Function GetSelectionMark() As Long
830 GetSelectionMark = SendMessage(myhWnd, LVM_GETSELECTIONMARK, 0, ByVal 0)
End Function

Private Function SetSelectionMark(ByVal i As Long) As Long
834 SetSelectionMark = SendMessage(myhWnd, LVM_SETSELECTIONMARK, 0, ByVal i)
End Function

Private Function SetHoverTime(ByVal dwHoverTimeMs As Long) As Long
838 SetHoverTime = SendMessage(myhWnd, LVM_SETHOVERTIME, 0, ByVal dwHoverTimeMs)
End Function

Private Function GetHoverTime() As Long
842 GetHoverTime = SendMessage(myhWnd, LVM_GETHOVERTIME, 0, ByVal 0&)
End Function

Private Function SetToolTips(ByVal NewHwnd As Long) As Long
846 SetToolTips = SendMessage(myhWnd, LVM_SETTOOLTIPS, NewHwnd, ByVal 0&)
End Function

Private Function GetToolTips() As Long
850 GetToolTips = SendMessage(myhWnd, LVM_GETTOOLTIPS, 0, ByVal 0&)
End Function

Private Function SetBkImage(plvbki As LVBKIMAGEW) As Boolean
854 SetBkImage = SendMessage(myhWnd, LVM_SETBKIMAGEW, 0, plvbki)
End Function

Private Function GetBkImage(plvbki As LVBKIMAGEW) As Boolean
858 GetBkImage = SendMessage(myhWnd, LVM_GETBKIMAGEW, 0, plvbki)
End Function

Private Function MAKELPARAM(ByVal LO_ As Integer, ByVal HI_ As Integer)
862 Dim d_ As Double
863 d_ = HI_
864 d_ = &H10000 * d_
865 MAKELPARAM = CLng(d_) + CLng(LO_)
End Function

Private Function CreateListView(ByVal ParentHWnd_ As Long, ByVal WinStyle_ As Long, ByVal ExStyle_ As Long) As Long
869 Dim rcClient As RECT ''' dimensions of client area
870 Dim hwnd_ As Long
871 GetClientRect ParentHWnd_, rcClient

873 hwnd_ = CreateWindowEx(ExStyle_, "SysListView32", "List View", WinStyle_, _
 0, 0, rcClient.Right, rcClient.Bottom, ParentHWnd_, 0, App.hInstance, 0)

875 If hwnd_ = 0 Then
876    Err.Raise vbObjectError, "UniListView", "System error " & Err.LastDllError & " in CreateWindowEx"
877 Else
878    CreateListView = hwnd_
879 End If
End Function

'Callback for LVAPI & message loop
Public Function WndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long 'no handlers
884 Dim hdr_ As NMHDR
885 Dim lvkey_ As NMLVKEYDOWN, wkey_ As Integer, char_ As String, kbst_(256) As Byte, wlen_ As Long, asc_ As Integer, locale_ As Long
886 Dim ia_ As NMITEMACTIVATE, is_ As NMLISTVIEW
887 On Error Resume Next
888 Select Case uMsg
'   Case WM_SIZE
''893    SetColWidths
'   Case WM_EXITSIZEMOVE
'892    Debug.Print "size end"

   Case WM_NOTIFY
895    CopyMemory ByVal VarPtr(hdr_), ByVal lParam, Len(hdr_)

897    Select Case hdr_.code

      Case LVN_KEYDOWN
900       CopyMemory ByVal VarPtr(lvkey_), ByVal lParam, Len(lvkey_)
901       RaiseEvent KeyDown(lvkey_.wVKey)

      Case LVN_ITEMACTIVATE
904       CopyMemory ByVal VarPtr(ia_), ByVal lParam, Len(ia_)
905       RaiseEvent ActivateItem(ia_.iItem)

      Case LVN_ITEMCHANGED
908       CopyMemory ByVal VarPtr(is_), ByVal lParam, Len(is_)
909       RaiseEvent SelectionChanged(is_.iItem)
910       If is_.iItem > -1 Then SetFocus

      Case LVN_COLUMNCLICK
913       CopyMemory ByVal VarPtr(is_), ByVal lParam, Len(is_)
914       RaiseEvent ColumnClick(is_.iSubItem)

      Case NM_RCLICK
917       RaiseEvent MouseRightClick

      Case Else
920       WndProc = CallWindowProc(myOrigWndProc, hwnd, uMsg, wParam, lParam)
921    End Select
   Case Else
923    WndProc = CallWindowProc(myOrigWndProc, hwnd, uMsg, wParam, lParam)
924 End Select
925 On Error GoTo 0
End Function


Private Sub UserControl_Hide()
930 UnRegisterLV UserControl.hwnd, myOrigWndProc  'ok put it back
End Sub

'subclass window
Private Sub UserControl_Initialize() 'no hanlders
935 myOrigWndProc = LVAPI.RegisterLV(Me, UserControl.hwnd)    'get the original window procedure address
936 UnRegisterLV UserControl.hwnd, myOrigWndProc  'ok put it back
937 myTextBuf = String(&H7FFF, 0)    'buffer for item data
End Sub

Private Sub UserControl_InitProperties()
942 myReadPropFlag = True
943 ViewStyle = Report
944 BackColor = vbWindowBackground
945 ForeColor = vbWindowText
946 myReadPropFlag = False
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
950 Dim sty_ As Long, exs_ As Long
951 myReadPropFlag = True
952 With PropBag
953    Border = .ReadProperty("Border", False)
954    Appearance = .ReadProperty("Special", 0)
955    HideColumnHeaders = .ReadProperty("ColHead", False)
956    NoColumnClick = .ReadProperty("NoColClick", False)
957    LabelEdit = .ReadProperty("Edit", False)
958    NoScroll = .ReadProperty("NoScroll", False)
959    LabelWrap = .ReadProperty("LabelWrap", False)
960    MultiSelect = .ReadProperty("SingleSel", True)
961    Sort = .ReadProperty("SortA", False)
962    ViewStyle = .ReadProperty("ViewStyle", LVS_REPORT)
963    HideSelection = .ReadProperty("HideSel", False)

'extended props
966    GridLines = .ReadProperty("Gridlines", False)
967    FullRowSelect = .ReadProperty("FullRowSelect", False)
968    CheckBoxes = .ReadProperty("CheckBoxes", False)
969    ActivationStyle = .ReadProperty("ActivateStyle", False)
970    FlatScrollbar = .ReadProperty("FlastSB", False)
971    HotTracking = .ReadProperty("ULineHot", False)
972    HeaderDragDrop = .ReadProperty("HeadDragDrop", False)
973    UserControl.Font.Bold = .ReadProperty("Font.Bold", False)
974    UserControl.Font.Charset = .ReadProperty("Font.Charset", False)
975    UserControl.Font.Italic = .ReadProperty("Font.Italic", False)
976    UserControl.Font.Name = .ReadProperty("Font.Name", UserControl.Font.Name)
977    UserControl.Font.Size = .ReadProperty("Font.Size", UserControl.Font.Size)
978 End With
979 myReadPropFlag = False

'set basic ViewStyle
982 sty_ = WS_VISIBLE Or WS_CHILD Or IIf(Border, WS_BORDER, 0) Or ViewStyle Or Sort Or _
IIf(HideColumnHeaders, LVS_NOCOLUMNHEADER, 0) Or IIf(LabelEdit, LVS_EDITLABELS, 0) Or _
IIf(NoScroll, LVS_NOSCROLL, 0) Or IIf(LabelWrap, 0, LVS_NOLABELWRAP) Or _
IIf(HideSelection, 0, LVS_SHOWSELALWAYS) Or IIf(MultiSelect, 0, LVS_SINGLESEL) Or _
IIf(NoColumnClick, LVS_NOSORTHEADER, 0)
'create window
984 myhWnd = CreateListView(UserControl.hwnd, sty_, Appearance)
'propeties appplicable only to myhWnd
986 ForeColor = PropBag.ReadProperty("ForeColor", vbWindowText)
987 BackColor = PropBag.ReadProperty("BackColor", vbWindowBackground)
988 FontKey = PropBag.ReadProperty("FontKey", "")

'ex listview styles
991 SetExtendedStyle
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
999 With PropBag
1000    .WriteProperty "ForeColor", ForeColor
1001    .WriteProperty "BackColor", BackColor

1003    .WriteProperty "Border", Border
1004    .WriteProperty "Special", Appearance
1005    .WriteProperty "ColHead", HideColumnHeaders
1006    .WriteProperty "NoColClick", NoColumnClick

1008    Call .WriteProperty("Edit", LabelEdit)
1009    Call .WriteProperty("NoScroll", NoScroll)
1010    Call .WriteProperty("LabelWrap", LabelWrap)

1012    Call .WriteProperty("SingleSel", MultiSelect)
1013    Call .WriteProperty("SortA", Sort)
1014    Call .WriteProperty("ViewStyle", ViewStyle)
1015    Call .WriteProperty("HideSel", HideSelection)

1017    .WriteProperty "Gridlines", GridLines
1018    .WriteProperty "FullRowSelect", FullRowSelect
1019    .WriteProperty "CheckBoxes", CheckBoxes
1020    .WriteProperty "ActivateStyle", ActivationStyle
1021    .WriteProperty "FlastSB", FlatScrollbar
1022    .WriteProperty "ULineHot", HotTracking
1023    .WriteProperty "HeadDragDrop", HeaderDragDrop
'414    .WriteProperty "ULineCold", UnderlineCold
'395    Call .WriteProperty("AlignLeft", AlignLeft)
'396    Call .WriteProperty("AutoArr", AutoArrange)
1027    Call .WriteProperty("Font.Bold", Me.Font.Bold)
1028    Call .WriteProperty("Font.Charset", Me.Font.Charset)
1029    Call .WriteProperty("Font.Italic", Me.Font.Italic)
1030    Call .WriteProperty("Font.Name", Me.Font.Name)
1031    Call .WriteProperty("Font.Size", Me.Font.Size)
1032    Call .WriteProperty("FontKey", myFontKey)
1033 End With
End Sub

Private Sub UserControl_Resize()
1037 Dim n_ As Long, n0_ As Long, n1_ As Long
1038 Dim ss_ As Long, wpx_ As Long, nw_ As Integer
1039 wpx_ = ScaleX(ScaleWidth, ScaleMode, vbPixels)

1041 MoveWindow myhWnd, 0, 0, wpx_, ScaleY(ScaleHeight, ScaleMode, vbPixels), True
1042 wpx_ = wpx_ - 2

'scale relative column widths
1045 If wpx_ > 0 And IsArray(myColArr) Then
1046    n0_ = LBound(myColArr)
1047    n1_ = UBound(myColArr)
1048    ss_ = Len(myHead) - (n1_ - n0_)
'###MLi
1050    For n_ = n0_ To n1_
1051       If Len(myColArr(n_)) > 0 Then nw_ = n_
1052       SetColumnWidth n_, Int(wpx_ * Len(myColArr(n_)) / ss_)
1053    Next n_
1054    If GetItemCount > GetCountPerPage Then
1055       SetColumnWidth nw_, Int(wpx_ * Len(myColArr(nw_)) / ss_) - 14
1056    End If
1057 End If

End Sub

Private Sub UserControl_Show()
1062 LVAPI.RegisterLV Me, UserControl.hwnd  'get the original window procedure address
End Sub

Private Sub UserControl_Terminate() 'no handlers
1066 On Error Resume Next
1067 Clear
1068 DestroyWindow myhWnd
End Sub

Private Sub SetColWidths()
1072 Dim n_ As Long, n0_ As Long, n1_ As Long
1073 Dim ss_ As Long, wpx_ As Long, nw_ As Integer
1074 wpx_ = ScaleX(ScaleWidth, ScaleMode, vbPixels)
'scale relative column widths
1076 If IsArray(myColArr) Then
1077    n0_ = LBound(myColArr)
1078    n1_ = UBound(myColArr)
1079    ss_ = Len(myHead) - (n1_ - n0_)
1080    For n_ = n0_ To n1_
1081       If Len(myColArr(n_)) > 0 Then nw_ = n_
1082       SetColumnWidth n_, Int(wpx_ * Len(myColArr(n_)) / ss_)
1083    Next n_
1084    If GetItemCount > GetCountPerPage Then
1085       SetColumnWidth nw_, Int(wpx_ * Len(myColArr(nw_)) / ss_) - 14
1086    End If
1087 End If
End Sub
